﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ChartView;

namespace wpf_ChartView_894198
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = this;

            var c = 365 * 24 * 60;
            var data = new List<Step>(c);
            var random = new Random();
            for (var minute = 0; minute < c; minute++)
            {
                var date = new DateTime(2006, 1, 1) + TimeSpan.FromMinutes(minute);
                var value = random.Next(1800, 2000);
                data.Add(new Step { Value = value, Date = date });
            }
            Data = data;

            this.Chart.ZoomChanged += this.Chart_ZoomChanged;
            this.UpdateAxisMajorStep();
        }

        public static readonly DependencyProperty DataProperty = DependencyProperty.Register("Data",
            typeof(IEnumerable<Step>), typeof(MainWindow), new PropertyMetadata(null));

        public IEnumerable<Step> Data
        {
            get { return (IEnumerable<Step>)GetValue(DataProperty); }
            set { SetValue(DataProperty, value); }
        }

        private void Chart_ZoomChanged(object sender, Telerik.Windows.Controls.ChartView.ChartZoomChangedEventArgs e)
        {
            this.UpdateAxisMajorStep();
        }

        private void UpdateAxisMajorStep()
        {
            double zoomFactor = this.Chart.Zoom.Width - (this.Chart.Zoom.Width % 2);
            zoomFactor = Math.Max(1, zoomFactor);
            var xAxis = ((DateTimeContinuousAxis)this.Chart.HorizontalAxis);
            xAxis.MajorStep = zoomFactor;
        }
    }

    public class Step
    {
        public Double Value { get; set; }
        public DateTime Date { get; set; }
    }
}